	list	p=16F628
	#include p16F628.inc
; INCRUSTATION COULEUR AVEC PIC
;  ALAIN REBOUX, 2004
; POUR ELECTRONIQUE PRATIQUE
DEP	EQU	H'0020'
NB_CAR	EQU	H'0021'
NB_TRAME	EQU	H'0022'
CAR	EQU	H'0023'
I	EQU	H'0024'
J	EQU	H'0025'
K	EQU	H'0026'
PL_CAR	EQU	H'0027'
L_CAR	EQU	H'0028'
NMR_MSG	EQU	H'0029'
NMR_PREC	EQU	H'002A'
OPER_1	EQU	H'002B'
OPER_2	EQU	H'002C'
RESULT	EQU	H'002D'
RESTE	EQU	H'002E'
VARIF	EQU	H'002F'
VBFOR1	EQU	H'0030'
VBFOR2	EQU	H'0031'
; (1) DFINITION DES TABLEAUX, VARIABLES ET TIQUETTES
SYNCV		EQU	2
SYNCH	EQU	4
RST_CLK	EQU	1
SORTIE	EQU	4	
; (2) CONFIGURATION ET INITIALISATION 
	__CONFIG  _EXTCLK_OSC&_WDT_OFF&_LVP_OFF
	ORG 0
	MOVLW	H'07'
	MOVWF	CMCON
INIT	BSF STATUS, RP0
	MOVLW	H'14'
	MOVWF	TRISA
	MOVLW	H'C0'
	MOVWF	TRISB
	BCF OPTION_REG,7
	BCF STATUS, RP0
	BSF PORTA,RST_CLK
	MOVLW	H'05'
	MOVWF	NMR_PREC
; PROGRAMME PRINCIPAL
; (3) D'ABORD ATTENTE DU SIGNAL DE SYNCHRO VERTICAL
ATT_SYNCV	BTFSC PORTA, SYNCV
	GOTO	ATT_SYNCV
; (4) DTERMINATION DU MESSAGE  AFFICHER
	MOVF	PORTB,0
	ANDLW	H'C0'
	MOVWF	NMR_MSG
	CLRF	RESULT
	MOVF	NMR_MSG,0
	MOVWF	OPER_1
	MOVLW	H'40'
	MOVWF	OPER_2
	CALL	DIV_OP
	MOVF	RESULT, 0
	MOVWF	NMR_MSG
	MOVF	NMR_MSG,0
	SUBWF	NMR_PREC,0
	BTFSC	STATUS,Z
	GOTO	ELSE1
	MOVLW	H'FF'
	MOVWF	NB_CAR
	MOVLW	H'00'
	MOVWF	NB_TRAME
	MOVLW	H'00'
	MOVWF	DEP
	MOVF	NMR_MSG,0
	MOVWF	NMR_PREC
ELSE1	NOP
	MOVLW	H'00'
	MOVWF	TMR0
	MOVF	NB_TRAME,0
	ADDLW	H'01'
	MOVWF	NB_TRAME
; (5) VITESSE DU DFILEMENT HORIZONTAL
	MOVF	NB_TRAME,0
	MOVWF	VARIF
	MOVLW	H'0C'
	SUBWF	VARIF,0
	BTFSC	STATUS,C
	GOTO	ELSE2
	GOTO	PREP_AFF
ELSE2	NOP
	MOVLW	H'00'
	MOVWF	NB_TRAME
	MOVF	DEP,0
	ADDLW	H'01'
	MOVWF	DEP
	MOVF	DEP,0
	SUBWF	NB_CAR,0
	BTFSC	STATUS,C
	GOTO	ELSE3
	MOVLW	H'00'
	MOVWF	DEP
ELSE3	NOP
; STOCKAGE EN MMOIRE DE LA PARTIE DU TEXTE  AFFICHER	
; (6) DTERMINER LA POSITION DE LA PORTION  AFFICHER
PREP_AFF	MOVLW	H'00'
	MOVWF	K
	SUBLW	H'0B'
	MOVWF	VBFOR1
	INCF	VBFOR1,1
SP_FOR1	NOP
	MOVLW	H'A0'
	ADDWF	K,0
	MOVWF	FSR
	MOVF	DEP,0
	ADDWF	K,0
	MOVWF	I
	MOVF	I,0
	SUBWF	NB_CAR,0
	BTFSC	STATUS,C
	GOTO	ELSE4
	MOVF	NB_CAR,0
	SUBWF	I,0
	MOVWF	I
ELSE4	NOP
; (7) SLECTIONNER LE BON TABLEAU CORRESPOND AU MESSAGE
	MOVF	NMR_MSG,0
	SUBLW	H'00'
	BTFSS	STATUS,Z
	GOTO	ELSE5
	MOVLW	H'03'
	MOVWF	PCLATH
	MOVF	I,0
	CALL	MESSAGE0
	MOVWF	CAR
ELSE5	NOP
	MOVF	NMR_MSG,0
	SUBLW	H'01'
	BTFSS	STATUS,Z
	GOTO	ELSE6
	MOVLW	H'04'
	MOVWF	PCLATH
	MOVF	I,0
	CALL	MESSAGE1
	MOVWF	CAR
ELSE6	NOP
	MOVF	NMR_MSG,0
	SUBLW	H'02'
	BTFSS	STATUS,Z
	GOTO	ELSE7
	MOVLW	H'05'
	MOVWF	PCLATH
	MOVF	I,0
	CALL	MESSAGE2
	MOVWF	CAR
ELSE7	NOP
	MOVF	NMR_MSG,0
	SUBLW	H'03'
	BTFSS	STATUS,Z
	GOTO	ELSE8
	MOVLW	H'06'
	MOVWF	PCLATH
	MOVF	I,0
	CALL	MESSAGE3
	MOVWF	CAR
ELSE8	NOP
; (8) CARACTRE "NORMAL" , ESPACE OU FIN DE MESSAGE
	MOVLW	H'40'
	SUBWF	CAR,0
	MOVWF	CAR
	BTFSS	STATUS,C
	CLRF CAR 
	MOVF	CAR,0
	SUBLW	H'3D'
	BTFSS	STATUS,Z
	GOTO	ELSE9
	CLRF CAR
	MOVF	I,0
	MOVWF	NB_CAR
ELSE9	NOP
	MOVF	CAR,0
	SUBLW	H'1A'
	BTFSC	STATUS,C
	GOTO	ELSE10
	CLRF CAR
ELSE10	NOP
; (9) MISE EN MMOIRE DE LA PORTION DE TEXTE  AFFICHER
	MOVLW	H'02'
	MOVWF	PCLATH
	MOVLW	H'00'
	MOVWF	J
	SUBLW	H'06'
	MOVWF	VBFOR2
	INCF	VBFOR2,1
SP_FOR2	NOP
	CLRF	RESULT
	MOVF	CAR,0
	MOVWF	OPER_1
	MOVLW	H'07'
	MOVWF	OPER_2
	CALL	MUL_OP
	MOVF	RESULT, 0
	MOVWF	PL_CAR
	MOVF	PL_CAR,0
	ADDWF	J,0
	MOVWF	PL_CAR
	MOVF	PL_CAR,0
	CALL	TAB_CAR
	MOVWF	INDF
	MOVF	FSR,0
	ADDLW	H'0C'
	MOVWF	FSR
	INCF	J,1
	DECFSZ	VBFOR2,1
	GOTO	SP_FOR2
	INCF	K,1
	DECFSZ	VBFOR1,1
	GOTO	SP_FOR1
; (10) ATTENTE 200 EME LIGNE
ATT_200	MOVF	TMR0,0
	MOVWF	VARIF
	MOVLW	H'C8'
	SUBWF	VARIF,0
	BTFSC	STATUS,C
	GOTO	ELSE11
	GOTO	ATT_200
ELSE11	NOP
; (11) AFFICHAGE DU MESSAGE
	MOVLW	H'A0'
	MOVWF	FSR
	MOVLW	H'07'
	MOVWF	J
AFF_7L	MOVLW	H'05'
	MOVWF	I
AFF_5F	BCF PORTA,RST_CLK
	BSF PORTA,RST_CLK
	CALL	LIGNE
	MOVLW	H'0B'
	SUBWF	FSR,0
	MOVWF	FSR
	DECFSZ	I,1
	GOTO	AFF_5F
	MOVF	FSR,0
	ADDLW	H'0C'
	MOVWF	FSR
	DECFSZ	J,1
	GOTO	AFF_7L
; (12) RETOUR AU DBUT	
	GOTO	ATT_SYNCV
; (13) LE SOUS PROGRAMME D'AFFICHAGE DES PIXELS
LIGNE	CALL	CYCLES8
	CALL	CYCLES8
	NOP
	NOP
	NOP
	NOP
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	INCF FSR,1
	MOVF	INDF,0
	MOVWF	PORTB
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	RLF PORTB,1
	BCF PORTB, SORTIE
	RETURN
; (14) PERTE DE TEMPS DE 8 CYCLES
CYCLES8	NOP
	NOP
	NOP
	NOP
	RETURN
; (15) LA TABLE DES CARACTRES ALPHABTIQUES
	ORG 200
TAB_CAR	ADDWF	PCL, 1
	RETLW	H'00'
	RETLW	H'00'
	RETLW	H'00'
	RETLW	H'00'
	RETLW	H'00'
	RETLW	H'00'
	RETLW	H'00'
	RETLW	H'0E'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'1F'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'1E'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'1E'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'1E'
	RETLW	H'0E'
	RETLW	H'11'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'11'
	RETLW	H'0E'
	RETLW	H'1C'
	RETLW	H'12'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'12'
	RETLW	H'1C'
	RETLW	H'1F'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'1E'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'1F'
	RETLW	H'1F'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'1E'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'0E'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'17'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'0F'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'1F'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'0E'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'0E'
	RETLW	H'07'
	RETLW	H'02'
	RETLW	H'02'
	RETLW	H'02'
	RETLW	H'02'
	RETLW	H'12'
	RETLW	H'0C'
	RETLW	H'11'
	RETLW	H'12'
	RETLW	H'14'
	RETLW	H'18'
	RETLW	H'14'
	RETLW	H'12'
	RETLW	H'11'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'1F'
	RETLW	H'11'
	RETLW	H'1B'
	RETLW	H'15'
	RETLW	H'15'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'19'
	RETLW	H'15'
	RETLW	H'13'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'0E'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'0E'
	RETLW	H'1E'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'1E'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'0E'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'15'
	RETLW	H'12'
	RETLW	H'0D'
	RETLW	H'1E'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'1E'
	RETLW	H'14'
	RETLW	H'12'
	RETLW	H'11'
	RETLW	H'0F'
	RETLW	H'10'
	RETLW	H'10'
	RETLW	H'0E'
	RETLW	H'01'
	RETLW	H'01'
	RETLW	H'1E'
	RETLW	H'1F'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'0E'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'0A'
	RETLW	H'04'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'15'
	RETLW	H'15'
	RETLW	H'0A'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'0A'
	RETLW	H'04'
	RETLW	H'0A'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'11'
	RETLW	H'0A'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'04'
	RETLW	H'1F'
	RETLW	H'01'
	RETLW	H'02'
	RETLW	H'04'
	RETLW	H'08'
	RETLW	H'10'
	RETLW	H'1F'
; (16) LES 4 MESSAGES QUI SERONT AFFICHS.
	ORG 300
MESSAGE0	ADDWF	PCL, 1
	DT "  LES REVES DEVIENNENT REALITE"
	DT " AVEC ELECTRONIQUE PRATIQUE        "
	DT " D AUTRES INFORMATIONS SUR LES PIC"
	DT " ET LA TELEVISION DANS LE LIVRE"
	DT " S INITIER A LA PROGRAMMATION DES PIC"
	DT " BASIC ET ASSEMBLEUR SECONDE EDITION" 
	DT " ALAIN REBOUX EDITIONS ETSF/DUNOD     }"
	ORG 400
MESSAGE1	ADDWF	PCL, 1
	DT " FLASH INFO SPECIAL"
	DT "   FLASH INFO SPECIAL"
	DT "   UNE LAN AURA LIEU A L ISEN BREST"
	DT " SAMEDI PROCHAIN   VENEZ EN NOMBRE"
	DT " PARTICIPER AU TOURNOI"
	DT " DE COUNTER STRIKE POUR AFFRONTER"
	DT " LES MEILLEURS  PATATE WAX HINOMURA"
	DT " VINCTWENTYNINE LEBOULET NASH ETC   }"
	ORG 500
MESSAGE2	ADDWF	PCL, 1
	DT " UN PETIT BONJOUR A MES AMIS"
	DT " PARAPENTISTES DU CLUB CELTIC DE VOL LIBRE"
	DT "    SI VOUS PASSEZ EN BRETAGNE FAITES UN TOUR"
	DT " PAR NOTRE MONTAGNE LE MENEZ HOM"
	DT " ET VENEZ ADMIRER CE SITE   }"
	ORG 600
MESSAGE3	ADDWF	PCL, 1
	DT " JE NE SAIS PLUS QUOI ECRIRE"
	DT " MAIS JE PENSE QUE VOUS AVEZ COMPRIS"
	DT " QU ON PEUT ECRIRE PRESQUE TOUT CE QU ON"
	DT " VEUT    MEME DES CRITIQUES ET JE VAIS AJOUTER"
	DT " BIENTOT LES CHIFFRES ET LA PONCTUATION"
	DT " COMME CA  CE SERA ENCORE PLUS BEAU ET"
	DT " TOUT LE MONDE S ABONNERA A ELECTRONIQUE"
	DT " PRATIQUE    }"   
MUL_OP	BTFSC STATUS, Z
	RETURN
	MOVF	OPER_1, 0
	ADDWF	RESULT, 1
	DECF	OPER_2, 1
	GOTO	MUL_OP
DIV_OP	INCF	RESULT, 1
	MOVF	OPER_2, 0
	SUBWF	OPER_1, 1
	BTFSC	STATUS, C
	GOTO	DIV_OP
	DECF	RESULT, 1
	ADDWF	OPER_1, 0
	MOVWF	RESTE
	RETURN
	NOP
	END
